/*******************************************************************************
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ, 
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
package at.asitplus.eidas.specific.connector.storage;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import eu.eidas.auth.commons.cache.ConcurrentMapService;
import eu.eidas.auth.commons.tx.AbstractCorrelationMap;

public class CacheWitheIDASBackend extends AbstractCorrelationMap<TransactionStoreElement> {

	protected CacheWitheIDASBackend(ConcurrentMapService concurrentMapService) {
		super(concurrentMapService);
	}
	
	public List<String> clean(Date now, long dataTimeOut) {
		List<String> result = new ArrayList<String>();
		Iterator<String> iterator = map.keySet().iterator();
		while (iterator.hasNext()) {
			String key = iterator.next();			
			if (map.containsKey(key)) {
				TransactionStoreElement element = map.get(key);				
				if (now.getTime() - element.getCreated().getTime() > dataTimeOut)
					result.add(key);
			}										
		}
		
		return result;
		
	}

}
