/*******************************************************************************
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ, 
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.asitplus.eidas.specific.connector;

import java.util.Arrays;
import java.util.List;

import at.gv.egiz.eaaf.core.api.data.EAAFConfigConstants;

public class MSeIDASNodeConstants {
	// ************ configuration properties ************
	public static final String PROP_CONFIG_APPLICATION_PREFIX = "eidas.ms.";	
	public static final String PROP_CONFIG_APPLICATION_PUBLIC_URL_PREFIX =  "context.url.prefix";
	public static final String PROP_CONFIG_APPLICATION_PUBLIC_URL_REQUEST_VALIDATION =  "context.url.request.validation";
	public static final String PROP_CONFIG_REVISIONLOG_LOG_IP_ADDRESS_OF_USER = "revisionlog.logIPAddressOfUser";
	public static final String PROP_CONFIG_REVISIONLOG_WRITE_MDS_INTO_REVISION_LOG = "revisionlog.write.MDS.into.revisionlog";
	public static final String PROP_CONFIG_TECHNICALLOG_WRITE_MDS_INTO_TECH_LOG = "technicallog.write.MDS.into.techlog";
			
	public static final String PROP_CONFIG_WEBCONTENT_STATIC_PATH = "webcontent.static.directory"; 
	
	public static final String PROP_CONFIG_MONITORING_EIDASNODE_METADATAURL = "monitoring.eIDASNode.metadata.url";
	
	private static final String PROP_CONFIG_PVP2_PREFIX =  "pvp2.";
	public static final String PROP_CONFIG_PVP2_KEYSTORE_PATH = PROP_CONFIG_PVP2_PREFIX + "keystore.path"; 
	public static final String PROP_CONFIG_PVP2_KEYSTORE_PASSWORD = PROP_CONFIG_PVP2_PREFIX + "keystore.password";	
	public static final String PROP_CONFIG_PVP2_KEY_METADATA_ALIAS = PROP_CONFIG_PVP2_PREFIX + "key.metadata.alias";	
	public static final String PROP_CONFIG_PVP2_KEY_METADATA_PASSWORD = PROP_CONFIG_PVP2_PREFIX + "key.metadata.password";
	public static final String PROP_CONFIG_PVP2_KEY_SIGNING_ALIAS = PROP_CONFIG_PVP2_PREFIX + "key.signing.alias";
	public static final String PROP_CONFIG_PVP2_KEY_SIGNING_PASSWORD = PROP_CONFIG_PVP2_PREFIX + "key.signing.password";
	public static final String PROP_CONFIG_PVP2_METADATA_VALIDITY = PROP_CONFIG_PVP2_PREFIX + "metadata.validity";	
	
	//TODO: is not implemented yet
	public static final String PROP_CONFIG_SP_VALIDATION_DISABLED = "configuration.sp.disableRegistrationRequirement";
	
	public static final String PROP_CONFIG_SP_LIST_PREFIX = "sp."; 
	public static final String PROP_CONFIG_SP_UNIQUEIDENTIFIER = EAAFConfigConstants.SERVICE_UNIQUEIDENTIFIER;
	public static final String PROP_CONFIG_SP_FRIENDLYNAME = "friendlyName";
	public static final String PROP_CONFIG_SP_PVP2_METADATA_URL = "pvp2.metadata.url";
	public static final String PROP_CONFIG_SP_PVP2_METADATA_TRUSTSTORE = "pvp2.metadata.truststore";
	public static final String PROP_CONFIG_SP_PVP2_METADATA_TRUSTSTORE_PASSWORD = "pvp2.metadata.truststore.password";
	public static final String PROP_CONFIG_SP_POLICY_ALLOWED_TARGETS = "policy.allowed.requested.targets";
	public static final String PROP_CONFIG_SP_POLICY_BASEIDTRANSFER_RESTRICTION = "policy.hasBaseIdTransferRestriction";
	
	public static final String PROP_CONFIG_PVP_SCHEME_VALIDATION = "configuration.pvp.scheme.validation";
	public static final String PROP_CONFIG_PVP_ENABLE_ENTITYCATEGORIES = "configuration.pvp.enable.entitycategories";
	
	// ********** default values ***************
	
	//Default policy for SP-targets requested by MOA-ID to ms-specific eIDAS Connector
	public static final String POLICY_DEFAULT_ALLOWED_TARGETS = ".*"; 
	//		                                                    EAAFConstants.URN_PREFIX_CDID.replaceAll("\\.", "\\\\.").replaceAll("\\+", "\\\\+") + ".*";
			
	public static final int METADATA_SOCKED_TIMEOUT = 20 * 1000;  	//20 seconds metadata socked timeout
	public static final int DEFAULT_PVP_METADATA_VALIDITY = 24;		//24 hours
	public static final int DEFAULT_PVP_ASSERTION_VALIDITY = 5;		//5 minutes
	
	
	// ************ application end-points *************
	public static final String ENDPOINT_PVP_METADATA = "/pvp/metadata";
	public static final String ENDPOINT_PVP_POST = "/pvp/post";
	public static final String ENDPOINT_PVP_REDIRECT = "/pvp/redirect";
	
	public static final String ENDPOINT_COUNTRYSELECTION = "/myHomeCountry";
	
	public static final String ENDPOINT_MONITORING_MONITOR = "/monitoring";
	public static final String ENDPOINT_MONITORING_VERIFY = "/verify";
	
	
	// ************ paths and templates ************
	public static final String CLASSPATH_TEMPLATE_DIR = "/templates/";
	public static final String FILESYSTEM_TEMPLATE_DIR = "./templates/";
	
	public static final String TEMPLATE_HTML_ERROR = "error_message.html";
	public static final String TEMPLATE_HTML_PVP_POSTBINDING = "pvp2_post_binding.html";
	public static final String TEMPLATE_HTML_COUNTRYSELECTION = "countrySelection.html";
	
	
	// ************ execution context and generic data ************
	public static final String REQ_PARAM_SELECTED_COUNTRY = "selectedCountry";
	public static final String REQ_PARAM_SELECTED_ENVIRONMENT = "selectedEnvironment";
	public static final String REQ_PARAM_STOP_PROCESS = "stopAuthProcess";
	
	public static final String REQ_PARAM_SELECTED_ENVIRONMENT_VALUE_PRODUCTION = "prod";
	public static final String REQ_PARAM_SELECTED_ENVIRONMENT_VALUE_QS = "qs";
	public static final String REQ_PARAM_SELECTED_ENVIRONMENT_VALUE_TESTING = "test";
	public static final String REQ_PARAM_SELECTED_ENVIRONMENT_VALUE_DEVELOPMENT = "dev";
	
	public static final String DATA_REQUESTERID = "req_requesterId";
	public static final String DATA_PROVIDERNAME = "req_providerName";
	public static final String DATA_REQUESTED_LOA_LIST = "req_requestedLoA";
	public static final String DATA_REQUESTED_LOA_COMPERISON = "req_requestedLoAComperision";
	
	public static final List<String> COUNTRY_SELECTION_PARAM_WHITELIST = 
			Arrays.asList(REQ_PARAM_SELECTED_COUNTRY, REQ_PARAM_SELECTED_ENVIRONMENT);
}
