/*******************************************************************************
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ, 
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
package at.asitplus.eidas.specific.modules.authmodule_eIDASv2.szr;

import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceFeature;

import szrservices.SZR;

/**
 * This class was generated by Apache CXF 3.1.16
 * 2018-07-10T09:36:01.466+02:00
 * Generated source version: 3.1.16
 * 
 */
@WebServiceClient(name = "SZRService", 
                  wsdlLocation = "./src/main/resources/szr_client/SZR-1.WSDL",
                  targetNamespace = "urn:SZRServices") 
public class SZRService extends Service {

    public final static URL WSDL_LOCATION;

    public final static QName SERVICE = new QName("urn:SZRServices", "SZRService");
    public final static QName SZRProduktionsumgebung = new QName("urn:SZRServices", "SZRProduktionsumgebung");
    public final static QName SZRTestumgebung = new QName("urn:SZRServices", "SZRTestumgebung");
    public final static QName SZRBusinesspartnerTestumgebung = new QName("urn:SZRServices", "SZRBusinesspartnerTestumgebung");
    static {
    	URL url = SZRService.class.getResource("./src/main/resources/szr_client/SZR-1.WSDL");
        if (url == null) {
            url = SZRService.class.getClassLoader().getResource("/szr_client/SZR-1.WSDL");
        } 
        if (url == null) {
            java.util.logging.Logger.getLogger(SZRService.class.getName())
                .log(java.util.logging.Level.INFO, 
                     "Can not initialize the default wsdl from {0}", "/szr_client/SZR-1.WSDL");
        }       
        WSDL_LOCATION = url;

    }

    public SZRService(URL wsdlLocation) {
        super(wsdlLocation, SERVICE);
    }

    public SZRService(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    public SZRService() {
        super(WSDL_LOCATION, SERVICE);
    }
    
    public SZRService(WebServiceFeature ... features) {
        super(WSDL_LOCATION, SERVICE, features);
    }

    public SZRService(URL wsdlLocation, WebServiceFeature ... features) {
        super(wsdlLocation, SERVICE, features);
    }

    public SZRService(URL wsdlLocation, QName serviceName, WebServiceFeature ... features) {
        super(wsdlLocation, serviceName, features);
    }    




    /**
     *
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRProduktionsumgebung")
    public SZR getSZRProduktionsumgebung() {
        return super.getPort(SZRProduktionsumgebung, SZR.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRProduktionsumgebung")
    public SZR getSZRProduktionsumgebung(WebServiceFeature... features) {
        return super.getPort(SZRProduktionsumgebung, SZR.class, features);
    }


    /**
     *
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRTestumgebung")
    public SZR getSZRTestumgebung() {
        return super.getPort(SZRTestumgebung, SZR.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRTestumgebung")
    public SZR getSZRTestumgebung(WebServiceFeature... features) {
        return super.getPort(SZRTestumgebung, SZR.class, features);
    }


    /**
     *
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRBusinesspartnerTestumgebung")
    public SZR getSZRBusinesspartnerTestumgebung() {
        return super.getPort(SZRBusinesspartnerTestumgebung, SZR.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns SZR
     */
    @WebEndpoint(name = "SZRBusinesspartnerTestumgebung")
    public SZR getSZRBusinesspartnerTestumgebung(WebServiceFeature... features) {
        return super.getPort(SZRBusinesspartnerTestumgebung, SZR.class, features);
    }

}
